type var = string

type typ =
  IntType
| BoolType
| ArrowType of typ * typ
| ProdType of typ * typ
| TypeVar of string

type expr =
  Var of var                      (* variables *)
| True | False                    (* boolean constants *)
| Int of int                      (* integer constants *)
| If of expr * expr * expr        (* if e1 then e2 else e3 *)
| Plus of expr * expr             (* e1 + e2 *)
| Pair of expr * expr             (* (e1, e2) *)
| Fst of expr                     (* fst e *)
| Snd of expr                     (* snd e *)
| Apply of expr * expr            (* e1 (e2) *)
| Lambda of var * expr            (* lambda x . e *)
| Let of var * expr * expr        (* let x = e1 in e2 end *)
| TypedLambda of var * typ * expr (* lambda x : type . e *)
