open Printf;;

if Array.length Sys.argv <> 2 then
  (printf "Usage: lam <file>\n";
   exit 0);;

(* Parse the given file and build the syntax tree (AST)
 * for the command that represents the program.
 * The syntax tree is stored in variable "com". *)
let file = open_in (Sys.argv.(1));;
let lexbuf = Lexing.from_channel file;;
let expr = try Parser.program Lexer.token lexbuf
          with Parsing.Parse_error ->
             let pos = lexbuf.Lexing.lex_curr_p in
             printf "Syntax error at line %d\n"
                    pos.Lexing.pos_lnum;
             exit 1;;

(* Pretty-print the command "com" *)
printf "Expression:\n\n";;
Pprint.pprintExpr expr;;
printf "\n\n";;

